// Created By July IGHOR
// JulyRegApi v1.2
// www.gigasoftgroup.com/JulyRegApi
// julyighor@gigasoftgroup.com

#include "julyregapi.h"
#include "windows.h"
#include <QStringList>

QString JulyRegApi::regReadString(HKEY_LIST list,QString path, QString val)
{
HKEY hKey;
if(RegOpenKeyEx((HKEY)list,path.utf16(),0,KEY_READ,&hKey)==ERROR_SUCCESS)
{
	DWORD dwSize = 512;
	wchar_t lszValue[512];
	bool noError=RegQueryValueEx(hKey,val.utf16(),NULL,NULL,(LPBYTE)lszValue,&dwSize)==ERROR_SUCCESS;
	RegCloseKey(hKey);
	if(noError)return QString::fromWCharArray(lszValue);
}
return 0;
}

QByteArray JulyRegApi::regReadArray(HKEY_LIST list,QString path, QString val)
{
HKEY hKey;
if(RegOpenKeyEx((HKEY)list,path.utf16(),0,KEY_READ,&hKey)==ERROR_SUCCESS)
{
	DWORD dwType=REG_BINARY;
	DWORD dwSize;
	bool noError=RegQueryValueEx(hKey,val.utf16(),NULL,&dwType,NULL,&dwSize)==ERROR_SUCCESS;
	if(noError)
	{
	void *pBuffer=(void *)malloc(dwSize);
	noError=RegQueryValueEx(hKey,val.utf16(),NULL,&dwType,(LPBYTE)pBuffer,&dwSize)==ERROR_SUCCESS;
	QByteArray result((char *)pBuffer,dwSize);
	free(pBuffer);
	RegCloseKey(hKey);
	if(noError)return result;
	}
	RegCloseKey(hKey);
}
return 0;
}

int JulyRegApi::regReadInt(HKEY_LIST list,QString path, QString val)
{
HKEY hKey;
if(RegOpenKeyEx((HKEY)list,path.utf16(),0,KEY_READ,&hKey)==ERROR_SUCCESS)
{
	DWORD data;
	DWORD dwType=REG_DWORD;
	DWORD dwSize;
	bool noError=RegQueryValueEx(hKey,val.utf16(),NULL,&dwType,(LPBYTE)&data,&dwSize)==ERROR_SUCCESS;
	RegCloseKey(hKey);
	if(noError)return (int)data;
}
return 0;
}

bool JulyRegApi::regWrite(HKEY_LIST list,QString path, QString val, QString data, bool createSubKeys)
{
HKEY hKey;
if(createSubKeys)RegCreateKey((HKEY)list,path.utf16(),&hKey);
if(RegOpenKeyEx((HKEY)list,path.utf16(),0,KEY_WRITE,&hKey)==ERROR_SUCCESS)
{
	bool noError=RegSetValueEx(hKey,val.utf16(),NULL,REG_SZ,(LPBYTE)data.utf16(),data.length()*2)==ERROR_SUCCESS;
	RegCloseKey(hKey);
	return noError;
}return false;
}

bool JulyRegApi::regWrite(HKEY_LIST list,QString path, QString val, QByteArray data, bool createSubKeys)
{
HKEY hKey;
if(createSubKeys)RegCreateKey((HKEY)list,path.utf16(),&hKey);
if(RegOpenKeyEx((HKEY)list,path.utf16(),0,KEY_WRITE,&hKey)==ERROR_SUCCESS)
{
	bool noError=RegSetValueEx(hKey,val.utf16(),NULL,REG_BINARY,(const BYTE *)data.data(),data.size())==ERROR_SUCCESS;
	RegCloseKey(hKey);
	return noError;
} return false;
}

bool JulyRegApi::regWrite(HKEY_LIST list,QString path, QString val, int data, bool createSubKeys)
{
HKEY hKey;
if(createSubKeys)RegCreateKey((HKEY)list,path.utf16(),&hKey);
if(RegOpenKeyEx((HKEY)list,path.utf16(),0,KEY_WRITE,&hKey)==ERROR_SUCCESS)
{
	bool noError=RegSetValueEx(hKey,val.utf16(),NULL,REG_DWORD,(LPBYTE)&data,sizeof(DWORD))==ERROR_SUCCESS;
	RegCloseKey(hKey);
	return noError;
}return false;
}

bool JulyRegApi::regRemove(HKEY_LIST list,QString path)
{
	return RegDeleteKey((HKEY)list,path.utf16());
}

bool JulyRegApi::regRemove(HKEY_LIST list,QString path, QString val)
{
HKEY hKey;bool result=false;
if(RegOpenKeyEx((HKEY)list,path.utf16(),0,KEY_WRITE,&hKey)==ERROR_SUCCESS)
{
	result=!RegDeleteValue(hKey,val.utf16());
	RegCloseKey(hKey);
}	return result;
}



QString JulyRegApi::shellUserName()
{return regReadString(HK_LOCAL_MACHINE,"SOFTWARE\\Microsoft\\Windows NT\\CurrentVersion\\Winlogon","DefaultUserName");}

QString JulyRegApi::shellComputerName()
	{return regReadString(HK_LOCAL_MACHINE,"SOFTWARE\\Microsoft\\Windows NT\\CurrentVersion\\Winlogon","DefaultDomainName");}

QString JulyRegApi::shellUserTemp()
	{return regReadString(HK_CURRENT_USER,"Environment","Temp");}
QString JulyRegApi::shellSystemTemp()
	{return regReadString(HK_LOCAL_MACHINE,"SYSTEM\\CurrentControlSet\\Control\\Session Manager\\Environment","Temp");}


QString JulyRegApi::shellWindowsDir()
	{return regReadString(HK_LOCAL_MACHINE,"SOFTWARE\\Microsoft\\Windows NT\\CurrentVersion","SystemRoot");}


void JulyRegApi::shellSetTempDir(QString newTempDir)
{
	regWrite(HK_CURRENT_USER,"Environment","Temp",newTempDir);
	regWrite(HK_CURRENT_USER,"Environment","Tmp",newTempDir);
	regWrite(HK_LOCAL_MACHINE,"SYSTEM\\CurrentControlSet\\Control\\Session Manager\\Environment","Temp",newTempDir);
	regWrite(HK_LOCAL_MACHINE,"SYSTEM\\CurrentControlSet\\Control\\Session Manager\\Environment","Tmp",newTempDir);
}